/********************************************************/
/*                                                      */
/*                  ROFF4, Version 1.60                 */
/*                                                      */
/*(C) 1983,4 by Ernest E. Bergmann                      */
/*              Physics, Building #16                   */
/*              Lehigh Univerisity                      */
/*              Bethlehem, Pa. 18015                    */
/*                                                      */
/* Permission is hereby granted for all commercial and  */
/* non-commercial reproduction and distribution of this */
/* material provided this notice is included.           */
/********************************************************/

/********************************************************/
/*                                                      */
/* modified by F.W.Glassborow dec 1988 for Atari ST	*/
/* and largely re-written january 1989			*/
/********************************************************/

/* 9/1/89	*/
/*10/1/89	*/
/*11/1/89	*/
/*12/1/89	*/
/*15/1/89	*/
/* mods for MS C 5.1  25/8/89 */
#include <stdio.h>

/* required files for Atari ST change as appropriate for other	*/
/* machines and/or compilers					*/
/*
#include <osbind.h>
#include <bios.h>
#include <ctype.h>
*/
/* IBM + MS C5.1 */
#include <conio.h>
#include <bios.h>
#include <ctype.h>

/* next remove default definition of putchar() so that it can be	*/
/* replaced by an internal function to handle multiple output channels.	*/

#undef putchar

/* next six #defines are compiler/machine specific low-level i/o definitions	*/
/* You MUST replace them with equivalents for your machine/compiler	*/
/* The given ones are for Mark Williams C on an Atari ST	*/

/*#define CONOUT(x)	Bconout(2,x)	/* output x to console		*/
/*#define CONIN		Bconin(2)	/* get input of 1 character from console	*/
/*#define PRINTOUT(x)	Bconout(0,x)	/* send to parallel printer 	*/
/*#define SERIALOUT(x)	Bconout(1,x)	/* for serial printer on Atari ST 	*/
/*#define CONSTAT		Bconstat(2)	/* console input status	*/
/*#define COSTAT		Bcostat(2)	/* console output status */

/* the following are the equivalent for MS C on IBM compatibles */
#define COM1		0
#define CONOUT(x)	putc(x,stdout)		/* output x to console		*/
#define CONIN		getchar()		/* get input of 1 character from console	*/
#define PRINTOUT(x)	putc(x,stdprn)		/* send to parallel printer 	*/
#define SERIALOUT(x)	_bios_serialcom(_COM_SEND,COM1,x)	/* for serial printer on COM1*/
#define CONSTAT		kbhit()		/* console input status	*/
#define COSTAT		TRUE		/* console output status */

/* a few constants for readability */

#define TRUE	1
#define FALSE	0
#define ERROR	(-1)
#define COMMAND	'.'		/* all commands starts with this */
#define UNKNOWN	-1		/* returned if doesn't recg. command */
#define NO_VAL	-32760  	/* returned when no argument w/commad */
#define WE_HAVE_A_WORD   1	/* returned by getwrd func. */
#define NO	0
#define YES	1
#define CR	0x0D
#define NUMSIGN	'#'	/* for title strings */
#define NEWLINE	'\n'
#define TAB	'\t'
#define BLANK	' '
#define FORMF	0x0C	/* formfeed for printer */
#define SQUOTE	0x27	/* single quote */
#define DQUOTE	0x22	/* double quote */
#define XCHAR	'-'
#define BELL	'\007'

/* configuration constants; allows tailoring to your needs and resources	*/

#define MAXLINE 255	/* maximum allowed space for input line	*/
#define STKSIZ	8	/* controls stacksize of stacked parameters */
#define HUGE	136	/* generally large number used to fill empty
			   space on a page with blank lines */
#define LSZ	255	/* line buffer size, limits processing space
				   in various buffers; see later */
#define TRSIZ	10000	/* size of TRTBL used to store macros, substitutions etc.
			   this should be ample as original version only allowed
			   about 1000 */
#define FMAX	6	/* max of additional files open; used by .SO	*/

struct divfd		/* for diversion files		*/
	{char *nm;	/* name				*/
	int cs;		/* character count		*/
	int ls;		/* line count			*/
	FILE *bf; 	/* to iobuf if open, FALSE otherwise*/
};

/* various global variables used as flags	*/

int PAGESTOP;		/* TRUE = wait at end of each page	*/
int JUSTIFY;		/* TRUE = right justify text		*/
int FFEED;		/* TRUE = send formfeed at end of page	*/
int SENTENCE;		/* TRUE = sentence terminator detected Nov 20*/
int SUPPRESS;		/* TRUE = no output is passed by putchar()*/
int PRNTR_FRMT;	/* TRUE = suppress CR's except those sent by brk(). Allows modern formatting printers to work. */
int NO_CRFLG;		/* suppress CR & LF at end of line if set  */
			/* introduced to handle formatting printers */
char _doflag;		/* flag if directed I/O being used */
int TFLAG;		/* added for start(), complete()*/
int msbfilter;		/* to allow for 8-bit ASCII, FGW 10/1/89	*/
int bit8;		/* used to set the msb if necessary, 12/1/89	*/

/* declare varables for defaults, set in roff4st.c			*/
/* changed by FGW to int's so that defaults can be changed without	*/
/* the need to recompile.  As the use of defaults has some significance	*/
/* this change is desirable						*/

int FI_DEF;
int LS_DEF;
int IN_DEF;
int RM_DEF;
int TI_DEF;
int CE_DEF;
int UL_DEF;
int M1_DEF;
int M2_DEF;
int M3_DEF;
int M4_DEF;
int PL_DEF;
int FF_DEF;		/* .ff defaults to "on" */
int FF_INI;		/* initial setting*/
int SC_INI;
int OW_INI;		/* initial output width*/
int TS_DEF;	 	/* standard tabsize*/
int TC_DEF;		/* translation flag default*/
int CF_DEF;		/* Dec 4*/
int IC_DEF;	
int CW_DEF;		/* 12/120" */
int JU_INI;		/* right justification		*/
int REGDEF;		/* default for register var.	*/
			/* when .rg has no numeric arg	*/
int PROP_DEF;		/* not proportional printing 	*/
int PAGES_DEF;		/* no wait at end of page	*/
int SP_DEF;		/* normally 1 line of space	*/
int STX_DEF;
int T_DEF;		/* used to allow set to be used even when default
			value is computed	*/


/* define numbers used for classification of symbols	*/

#define TRANSLATE	2	/* May 23, 1983*/
#define BLACK		1
#define WHITE		0
#define CONTROL		-1
#define SENTINEL	-2
#define HTAB		-3
#define OTHERS		-4

/* assign numerical values to the dot command codes */

#define FI		1	/* fill lines */
#define TI		2	/* temporary indent */
#define BP		3	/* begin page  */
#define BR		4	/* causes break */
#define CE		5	/* center line(s) */
#define IN		7	/* left indent */
#define LS		8	/* line spacing */
#define NF		9	/* no fill */
#define PL		10	/* set page length */
#define RM		11	/* set right margin */
#define SP		12	/* add blank line(s) */
#define STX		13	/* stop(pause) at page start?*/
#define FO		14	/* footer title */
#define HE		15	/* header title */
#define M1		16	/* top margin */
#define M2		17	/* second top margin */
#define M3		18	/* first bottom margin */
#define M4		19	/* bottom-most margin	*/
#define IG		20	/* "ignore";comments,Nov 6,82*/
#define NE		21	/* "need";Nov 7,82*/
#define FF		22	/* "formfeed";Nov 10*/
#define SC		23	/* "space character";Nov13*/
#define OW		24	/* "output width";Nov 13*/
#define TS		25	/* "tabsize";Nov 13*/
#define EH		26	/* "even headers";Nov 14*/
#define OH		27	/* "odd headers"*/
#define EF		28	/* "even footers"*/
#define OF		29	/* "odd footers"*/
#define AB		30	/* "abort";Nov 15*/
#define DB		31	/* "debug"*/
#define TC		32	/* "translation flag char"*/
#define TR		33	/* "def translation string"*/
#define CF		34	/* Dec 4:control flag char*/
#define IC		35	/* insert character */
#define OU		36	/* output */
#define JU		37	/* right justify?*/
#define NJ		38	/* don't right justify*/
#define WH		39	/* whole line spacing code*/
#define FR		40	/* fractional spacing,code*/
#define DS		41	/* define string*/
#define DM		42	/* define macro*/
#define EM		43	/* end macro*/
#define RG		44	/* register variable*/
#define DI		45	/* diversion*/
#define ED		46	/* end diversion*/
#define SO		47	/* "source", include*/
#define PC		48	/* printer control definition*/
#define SA		49	/* "say" inline msg to console*/
#define BJ		50	/* break with right justification of current line*/
/* FGW's new commands for modern printers	*/
#define PF		51	/* proportional spacing 10/1/89*/
#define RF		52	/* Equal letter spacing, undoes PF 10/1/89 */
#define AL		53	/* adjust line count for double height 22 dec 88 */
#define AS		54	/* new command to allow for 8-bit ASCII option */

/* parameter stacks. Redone dec 88 so that only stacks are used	*/

int _FILL[STKSIZ+1];		/* convert global value to a stack*/
int _LSVAL[STKSIZ+1];		/* line spacing value -> default will be 1 */
int _INVAL[STKSIZ+4];		/* left indent -> default  0 */
int _RMVAL[STKSIZ+1];		/* right margin -> default  PAGEWIDTH */
int _TCVAL[STKSIZ+1];		/* translation flag int*/
int _PLVAL[STKSIZ+1];		/* page length in lines */
int _M1VAL[STKSIZ+1];		/* margin before& including header in lines*/
int _M2VAL[STKSIZ+1];		/* margin after header in lines*/
int _M3VAL[STKSIZ+1];		/* margin after last text line in lines*/
int _M4VAL[STKSIZ+1];		/* bottom margin, including footer in lines*/
int _SCVAL[STKSIZ+1];		/* space intacter*/
int _OWVAL[STKSIZ+1];		/* output device width*/
int _TABSIZ[STKSIZ+1];		/* spacing of tabstops*/
int _CFVAL[STKSIZ+1];		/* Dec 4:control flag intacter value*/
int _ICVAL[STKSIZ+1];		/* insert character*/

/* other global variables	*/

int TIVAL;			/* temporary indent -> default  0 */
int CEVAL;			/* set equal to number of lines to be centered  */
int SPVAL;			/* blank lines to be spaced down */
int CURPAG;			/* current output page number; init = 0 */
int NEWPAG;			/* next output page number; init = 1 */
int VLINENO;			/* virtual (intended) line advances on page, see vadv()*/
int FVLINENO;   		/* + line fraction */
int PLINENO;			/* printer's actual line advances on page, see padv()*/
int FPLINENO;   		/* + line fraction */
int BOTTOM;			/* end of text area in lines;start of M3+M4 */
int LINKNO;			/* 11/1/89 for modified diversion file handling	*/

char OUTBUF[ LSZ ];		/*lines to be filled collected here */
char LINE[ LSZ ];		/*input line buffer, Nov 26*/
char EHEAD[ LSZ ],*EH2,*EH3;	/* even header title */
char OHEAD[ LSZ ],*OH2,*OH3;	/* odd header title */
char EFOOT[ LSZ ],*EF2,*EF3;	/* even footer title */
char OFOOT[ LSZ ],*OF2,*OF3;	/* even footer title */
char OUTBUF2[LSZ];		/*for line to be output in fancy fmt*/
char XBUF[LSZ];			/*strikout buffer*/

/* global values to keep track of details in output	*/

int OUTWRDS;		/* no. words in OUTBUF; init = 0 */
int OUTW;		/* current display width of OUTBUF*/
int OUTPOS;		/*  =strlen(OUTBUF) */
int WTOP,LTOP,OUTTOP;   /* zero|negative;levels of subscripts*/
int WBOT,LBOT,OUTBOT;   /* zero|positive;levels of subscripts*/
int OLDLN;		/* position of previous main line*/
int OLDBOT;		/* OUTBOT for previous line;reset each page*/

/* fractional/whole line spacing	*/

int FRQ,FRVAL;  	/* fractional line?, what fraction size*/
char *FRSTRING; 	/* ^ to code for fractional spacing*/
char *WHSTRING;		/* ^ to code for whole line spacing*/

/* substitution tables and pointers. Completely redone by FGW dec 88 */

char *CPTR[96];		/* pointer table for print control*/
char *TPTR[96];		/* pointer table for translation strings for char; initialize to null */
char TRTBL[TRSIZ];	/* holds translation strings etc.*/
char *TREND;		/* after end of last entry in the above;init = TRTBL*/

/* the following tables hold pointers into TRTBL for macros, diversion files,	*/
/* registers  and substitution strings					*/

#define	DMAXFILES	20	/* 11/1/89 rewrite of diversion files by FGW	*/
char *MLINK[256], *DLINK[DMAXFILES],*RLINK[256],*SLINK[256];

struct divfd DLINKDATA[DMAXFILES];	/* diversion file data storage 11/1/89	*/
int RLINKDATA[256];	/* for register values	11/1/89 */

/* and these keep count of the entries and hence index the next entry in the relevant table	*/

int   MLINKPTR,    DLINKPTR,   RLINKPTR,   SLINKPTR;

/* globals used by multi-pass print routines. Note some of the original multi-
   pass requirements have been removed by FGW dec 88	*/

int BPOS,CP,PP;		/* buffer,column,printer positions*/
int XF,XCOL,NEWXF;	/* " flag and column and holding variable*/
int FIRST;		/* flag for first pass*/
int BLKCNT;
char LASTCH;		/* 5th Mar,85  ;  Conrad Kwok */
int REVSCROLL;	/* and might as well stay that way	*/

char BACKBUF[LSZ];	/* used to expand inputline	*/
int BINP;		/* position in above;init to 0		*/
char KEYBD;		/* boolean & prompt for keyboard input	*/
char KLINE[MAXLINE];	/* keyboard line input buffer	*/
char *KPTR;		/* pointer for above*/


/* stack for .SO files and other files	*/
int	FPTR;
FILE *FSTACK[FMAX];
FILE *_dobuf,*IOBUF;	/* /O buffer used for direction  */

int FIRSTPAGE,LASTPAGE;		/*for selectively printing output*/
#define STDERR	stderr		/* send error messages to console while in DIO */

/* function declarations */

char *find2();
char getcode();
char *macq();
char *fgets2();


